# libhla Namespace Reference

## Classes
struct | LittleEndian
| Conversion to the Little Endian encoding. More...
struct | BigEndian
| Conversion to the Big Endian encoding. More...
struct | libhla::__swap< T, 1 >
struct | libhla::__swap< T, 2 >
struct | libhla::__swap< T, 4 >
struct | libhla::__swap< T, 8 >
struct | HLAbasicType
| HLA basic type, represented by <T> type stored in <S> using <E> encoding. More...
class | __HLAbuffer
struct | HLAenumeratedType
| HLA enumerated type, enumeration <E> with representation <R>. More...
struct | libhla::HLAfixedArray< M, N, false >
struct | libhla::HLAfixedArray< M, N, true >
struct | libhla::HLAfixedRecord< R, false >
struct | libhla::HLAfixedRecord< R, true >
struct | libhla::HLAfixedField< E, M, N, false >
struct | libhla::HLAfixedField< E, M, N, true >
struct | HLAfixedEnd
| Defines a last field in the fixed record. More...
struct | __fixedRecord_if
struct | libhla::__fixedRecord_if< false, Then, Else >
struct | libhla::__FieldAt< HLAfixedField< E, M, N, V >, d >
struct | libhla::__FieldAt< HLAfixedEnd, d >
class | HLAdata
struct | libhla::HLAvariableArray< M, false >
struct | libhla::HLAvariableArray< M, true >
struct | HLAASCIIstring
struct | libhla::HLAvariantRecord< DE, DM, R, false >
struct | libhla::HLAvariantRecord< DE, DM, R, true >
struct | HLAsetValue
| Defines a value in an enumerator list; to be used with HLAvariantField. More...
struct | HLAsetRange
| Defines a range in an enumerator list. More...
struct | HLAsetOther
| Defines the "HLAother" symbol in an enumerator list. More...
struct | HLAsetEnd
| Defines the end of an enumerator list. More...
struct | libhla::HLAvariantField< D, E, M, N, false >
struct | libhla::HLAvariantField< D, E, M, N, true >
struct | HLAvariantEnd
| Defines a last field in the fixed record. More...
struct | __variantRecord_if
struct | libhla::__variantRecord_if< false, Then, Else >
struct | __DiscriminantOrFieldAt
struct | libhla::__FieldAt< HLAvariantField< D, E, M, N, V >, e >
struct | libhla::__FieldAt< HLAvariantEnd, e >
## Typedefs
typedef HLAbasicType< short, int16_t, BigEndian > | HLAinteger16BE
typedef HLAbasicType< long, int32_t, BigEndian > | HLAinteger32BE
typedef HLAbasicType< long long, int64_t, BigEndian > | HLAinteger64BE
typedef HLAbasicType< float, float, BigEndian > | HLAfloat32BE
typedef HLAbasicType< double, double, BigEndian > | HLAfloat64BE
typedef HLAbasicType< wchar_t, wchar_t, BigEndian > | HLAoctetPairBE
typedef HLAbasicType< short, int16_t, LittleEndian > | HLAinteger16LE
typedef HLAbasicType< long, int32_t, LittleEndian > | HLAinteger32LE
typedef HLAbasicType< long long, int64_t, LittleEndian > | HLAinteger64LE
typedef HLAbasicType< float, float, LittleEndian > | HLAfloat32LE
typedef HLAbasicType< double, double, LittleEndian > | HLAfloat64LE
typedef HLAbasicType< wchar_t, wchar_t, LittleEndian > | HLAoctetPairLE
typedef HLAbasicType< char, char, BigEndian > | HLAoctet
typedef HLAoctet | HLAASCIIchar
typedef HLAoctetPairBE | HLAunicodeChar
typedef HLAoctet | HLAbyte
typedef HLAbasicType< unsigned short, uint16_t, BigEndian > | Unsignedinteger16BE
typedef HLAbasicType< unsigned long, uint32_t, BigEndian > | Unsignedinteger32BE
typedef HLAbasicType< unsigned long, uint64_t, BigEndian > | Unsignedinteger64BE
typedef HLAenumeratedType < __HLAboolean, HLAinteger32BE > | HLAboolean
typedef HLAvariableArray < HLAunicodeChar > | HLAunicodeString
typedef HLAvariableArray< HLAbyte > | HLAopaqueData
## Enumerations
enum | __HLAboolean { HLAfalse = 0, HLAtrue = 1 }
## Functions
template<class T, class S, template< class T >class E>
std::ostream & | PrintBuffer (std::ostream &stream, HLAbasicType< T, S, E > &buffer)
std::ostream & | __print_buffer (std::ostream &stream, const void *buffer, size_t length)
| Print the physical data buffer (for debugging purposes only).
size_t | __padding (size_t size, size_t boundary)
template<class M, int N, bool hasVariable>
std::ostream & | PrintBuffer (std::ostream &stream, HLAfixedArray< M, N, hasVariable > &buffer)
template<class R, bool V>
std::ostream & | PrintBuffer (std::ostream &stream, HLAfixedRecord< R, V > &buffer)
template<class M, bool hasVariable>
std::ostream & | PrintBuffer (std::ostream &stream, HLAvariableArray< M, hasVariable > &buffer)
template<int DE, class DM, class R, bool V>
std::ostream & | PrintBuffer (std::ostream &stream, HLAvariantRecord< DE, DM, R, V > &buffer)

## Typedef Documentation

typedef HLAoctet HLAASCIIchar

Definition at line 196 of file HLAbasicType.hh.

typedef HLAenumeratedType<__HLAboolean, HLAinteger32BE> HLAboolean

Definition at line 96 of file HLAenumeratedType.hh.

typedef HLAoctet HLAbyte

Definition at line 198 of file HLAbasicType.hh.

typedef HLAbasicType<float, float, BigEndian> HLAfloat32BE

Definition at line 180 of file HLAbasicType.hh.

typedef HLAbasicType<float, float, LittleEndian> HLAfloat32LE

Definition at line 187 of file HLAbasicType.hh.

typedef HLAbasicType<double, double, BigEndian> HLAfloat64BE

Definition at line 181 of file HLAbasicType.hh.

typedef HLAbasicType<double, double, LittleEndian> HLAfloat64LE

Definition at line 188 of file HLAbasicType.hh.

typedef HLAbasicType<short, int16_t, BigEndian> HLAinteger16BE

Definition at line 177 of file HLAbasicType.hh.

typedef HLAbasicType<short, int16_t, LittleEndian> HLAinteger16LE

Definition at line 184 of file HLAbasicType.hh.

typedef HLAbasicType<long, int32_t, BigEndian> HLAinteger32BE

Definition at line 178 of file HLAbasicType.hh.

typedef HLAbasicType<long, int32_t, LittleEndian> HLAinteger32LE

Definition at line 185 of file HLAbasicType.hh.

typedef HLAbasicType<long long, int64_t, BigEndian> HLAinteger64BE

Definition at line 179 of file HLAbasicType.hh.

typedef HLAbasicType<long long, int64_t, LittleEndian> HLAinteger64LE

Definition at line 186 of file HLAbasicType.hh.

typedef HLAbasicType<char, char, BigEndian> HLAoctet

Definition at line 191 of file HLAbasicType.hh.

typedef HLAbasicType<wchar_t, wchar_t, BigEndian> HLAoctetPairBE

Definition at line 182 of file HLAbasicType.hh.

typedef HLAbasicType<wchar_t, wchar_t, LittleEndian> HLAoctetPairLE

Definition at line 189 of file HLAbasicType.hh.

typedef HLAvariableArray<HLAbyte> HLAopaqueData

Definition at line 238 of file HLAvariableArray.hh.

typedef HLAoctetPairBE HLAunicodeChar

Definition at line 197 of file HLAbasicType.hh.

typedef HLAvariableArray<HLAunicodeChar> HLAunicodeString

Definition at line 237 of file HLAvariableArray.hh.

typedef HLAbasicType<unsigned short, uint16_t, BigEndian> Unsignedinteger16BE

Definition at line 202 of file HLAbasicType.hh.

typedef HLAbasicType<unsigned long, uint32_t, BigEndian> Unsignedinteger32BE

Definition at line 203 of file HLAbasicType.hh.

typedef HLAbasicType<unsigned long, uint64_t, BigEndian> Unsignedinteger64BE

Definition at line 204 of file HLAbasicType.hh.

## Enumeration Type Documentation

enum __HLAboolean

Enumerator:

  HLAfalse |
  HLAtrue |

Definition at line 92 of file HLAenumeratedType.hh.

## Function Documentation

size_t libhla::__padding | ( | size_t | size,
|  | size_t | boundary |
| ) |  |  | `[inline]`

Definition at line 178 of file HLAbuffer.hh.

Referenced by HLAfixedField< E, M, N, true >::__sizeof(), HLAfixedField< E, M, N, false >::__sizeof(), HLAvariableArray< M, true >::copy(), HLAvariableArray< M, false >::copy(), HLAfixedField< E, M, N, true >::copy(), HLAfixedField< E, M, N, false >::copy(), HLAfixedArray< M, N, true >::copy(), HLAfixedArray< M, N, false >::copy(), HLAvariantRecord< DE, DM, R, true >::emptysizeof(), HLAvariantRecord< DE, DM, R, false >::emptysizeof(), HLAvariableArray< M, true >::emptysizeof(), HLAvariableArray< M, false >::emptysizeof(), HLAfixedField< E, M, N, true >::emptysizeof(), HLAfixedArray< M, N, true >::emptysizeof(), HLAfixedField< E, M, N, true >::field_offsetof(), HLAfixedField< E, M, N, false >::field_offsetof(), HLAvariableArray< M, true >::offset(), HLAvariableArray< M, false >::offset(), HLAfixedArray< M, N, true >::offset(), HLAfixedArray< M, N, false >::offset(), HLAvariableArray< M, true >::set_size(), and HLAvariableArray< M, false >::set_size().

HLA_EXPORT std::ostream & __print_buffer | ( | std::ostream & | stream,
|  | const void * | buffer,
|  | size_t | length |
| ) |  |  |

Print the physical data buffer (for debugging purposes only).

Definition at line 48 of file HLAbuffer.cc.

Referenced by __HLAbuffer::print(), and PrintBuffer().

std::ostream& libhla::PrintBuffer | ( | std::ostream & | stream,
|  | HLAvariantRecord< DE, DM, R, V > & | buffer |
| ) |  |  | `[inline]`

Definition at line 72 of file HLAvariantRecord.hh.

References __print_buffer().

Here is the call graph for this function:

std::ostream& libhla::PrintBuffer | ( | std::ostream & | stream,
|  | HLAvariableArray< M, hasVariable > & | buffer |
| ) |  |  | `[inline]`

Definition at line 51 of file HLAvariableArray.hh.

References __print_buffer().

Here is the call graph for this function:

std::ostream& libhla::PrintBuffer | ( | std::ostream & | stream,
|  | HLAfixedRecord< R, V > & | buffer |
| ) |  |  | `[inline]`

Definition at line 69 of file HLAfixedRecord.hh.

References __print_buffer().

Here is the call graph for this function:

std::ostream& libhla::PrintBuffer | ( | std::ostream & | stream,
|  | HLAfixedArray< M, N, hasVariable > & | buffer |
| ) |  |  | `[inline]`

Definition at line 48 of file HLAfixedArray.hh.

References __print_buffer().

Here is the call graph for this function:

std::ostream& libhla::PrintBuffer | ( | std::ostream & | stream,
|  | HLAbasicType< T, S, E > & | buffer |
| ) |  |  | `[inline]`

Definition at line 171 of file HLAbasicType.hh.

References __print_buffer(), and HLAbasicType::__sizeof().

Here is the call graph for this function: